#region Copyright

/*
 * Copyright 2006 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */

#endregion

using System;
using System.Collections.Generic;
using System.Reflection;
using System.Windows.Forms;
using Seasar.Framework.Aop;
using Seasar.Framework.Aop.Interceptors;
using Seasar.Framework.Container;
using Seasar.Windows.Attr;

namespace Seasar.Windows.AOP.Interceptors
{
    /// <summary>
    /// w肳ꂽForm\Interceptor
    /// </summary>
    public class FormInterceptor : AbstractInterceptor
    {
        /// <summary>
        /// DIRei
        /// </summary>
        private IS2Container container_;

        /// <summary>
        /// ԂlpvpeB
        /// </summary>
        private string returnPropertyName_;

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="container">DIRei</param>
        public FormInterceptor(IS2Container container)
        {
            container_ = container;
            returnPropertyName_ = "";
        }

        /// <summary>
        /// ԂlpvpeB
        /// </summary>
        public string Property
        {
            get { return returnPropertyName_; }
            set { returnPropertyName_ = value; }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="invocation"></param>
        /// <returns>DialogResult</returns>
        /// <remarks>Default̖߂lDialgResult.No</remarks>
        public override object Invoke(IMethodInvocation invocation)
        {
            DialogResult retOfReplace = DialogResult.No;

            object ret = retOfReplace;

            string propertyName;

            // \bḧl̎擾
            object[] args = invocation.Arguments;
            ParameterInfo[] pis = invocation.Method.GetParameters();
            IDictionary<string, object> hashOfParams = new Dictionary<string, object>();
            IList<string> listOfParams = new List<string>();
            foreach (ParameterInfo pi in pis)
            {
                hashOfParams.Add(pi.Name, args[pi.Position]);
                listOfParams.Add(pi.Name);
            }

            // WindowsForm̕\
            object[] attributes = invocation.Method.GetCustomAttributes(false);
            foreach (object o in attributes)
            {
                if ( o is TargetFormAttribute )
                {
                    TargetFormAttribute attribute = (TargetFormAttribute) o;
                    Type formType = attribute.FormType;
                    Form form = (Form) container_.GetComponent(formType);

                    if ( attribute.ReturnPropertyName != "" )
                        propertyName = attribute.ReturnPropertyName;
                    else
                    {
                        if ( returnPropertyName_ != null )
                            propertyName = returnPropertyName_;
                        else
                            propertyName = "";
                    }
                    for ( int i = 0; i < listOfParams.Count; i++ )
                    {
                        PropertyInfo property = form.GetType().GetProperty(listOfParams[i]);
                        property.SetValue(form, hashOfParams[listOfParams[i]], null);
                    }

                    if ( attribute.Mode == ModalType.Modal )
                    {
                        retOfReplace = form.ShowDialog();
                        ret = retOfReplace;

                        // WindowsForm߂lpvpeBl擾
                        if ( propertyName != "" )
                        {
                            PropertyInfo propInfo = form.GetType().GetProperty(propertyName);
                            if ( propInfo != null )
                                ret = propInfo.GetValue(form, null);
                        }
                    }
                    else
                        form.Show();
                }
            }

            return ret;
        }
    }
}